------------------------------------------------------------------------------
-- BUSH Sequential IO - Byte_IO Package Parser                              --
--                                                                          --
-- Part of BUSH                                                             --
------------------------------------------------------------------------------
--                                                                          --
--              Copyright (C) 2001-2004 Ken O. Burtch & FSF                 --
--                                                                          --
-- This is free software;  you can  redistribute it  and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion.  This is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License  distributed with this;  see file COPYING.  If not, write --
-- to  the Free Software Foundation,  59 Temple Place - Suite 330,  Boston, --
-- MA 02111-1307, USA.                                                      --
--                                                                          --
-- This is maintained at http://www.pegasoft.ca                             --
--                                                                          --
------------------------------------------------------------------------------
-- CVS: $Header: /home/cvsroot/ada/bush/parser_lock.ads,v 1.1.1.1 2003/10/16 03:08:02 ken Exp $

with ada.strings.unbounded, world;
use  ada.strings.unbounded, world;

package parser_bio is


------------------------------------------------------------------------------
-- Byte_IO package identifiers
------------------------------------------------------------------------------

bio_file_type_t   : identifier;
bio_in_file_t     : identifier;  -- file_mode value 'in_file'
bio_out_file_t    : identifier;  -- file_mode value 'out_file'
bio_append_file_t : identifier; -- file_mode value 'append_file'

bio_create_t      : identifier;
bio_open_t        : identifier;
bio_close_t       : identifier;
bio_delete_t      : identifier;
bio_reset_t       : identifier;
bio_mode_t        : identifier;
bio_name_t        : identifier;
bio_form_t        : identifier;
bio_read_t        : identifier;
bio_write_t       : identifier;
bio_eof_t         : identifier;

------------------------------------------------------------------------------
-- HOUSEKEEPING
------------------------------------------------------------------------------

procedure StartupByteIO;
procedure ShutdownByteIO;

------------------------------------------------------------------------------
-- PARSE THE Byte_IO PACKAGE
------------------------------------------------------------------------------

procedure bio_create;
procedure bio_open;
procedure bio_close;
procedure bio_delete;
procedure bio_reset;
procedure bio_mode( result : out unbounded_string );
procedure bio_name( result : out unbounded_string );
procedure bio_form( result : out unbounded_string );
procedure bio_read;
procedure bio_write;
procedure bio_eof;

end parser_bio;
