------------------------------------------------------------------------------
-- BUSH SDL (Simple Direct Media Layer) Package Parser                      --
--                                                                          --
-- Part of BUSH                                                             --
------------------------------------------------------------------------------
--                                                                          --
--              Copyright (C) 2001-2004 Ken O. Burtch & FSF                 --
--                                                                          --
-- This is free software;  you can  redistribute it  and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion.  This is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License  distributed with this;  see file COPYING.  If not, write --
-- to  the Free Software Foundation,  59 Temple Place - Suite 330,  Boston, --
-- MA 02111-1307, USA.                                                      --
--                                                                          --
-- This is maintained at http://www.pegasoft.ca                             --
--                                                                          --
------------------------------------------------------------------------------
-- CVS: $Header$

with ada.strings.unbounded, world;
use  ada.strings.unbounded, world;

package parser_sdl is


------------------------------------------------------------------------------
-- SDL package identifiers
------------------------------------------------------------------------------

  sdl_init_flag_t : identifier;
  sdl_init_timer_t : identifier;
  sdl_init_audio_t : identifier;
  sdl_init_video_t : identifier;
  sdl_init_cdrom_t : identifier;
  sdl_init_joystick_t : identifier;
  sdl_no_parachute_t : identifier;
  sdl_eventthread_t : identifier;
  sdl_eventthing_t : identifier;
                                                                                
  sdl_init_t : identifier;
  sdl_quit_t : identifier;

------------------------------------------------------------------------------
-- HOUSEKEEPING
------------------------------------------------------------------------------

procedure StartupSDL;
procedure ShutdownSDL;

------------------------------------------------------------------------------
-- PARSE THE SDL PACKAGE
------------------------------------------------------------------------------

procedure ParseSDLInit;
procedure ParseSDLQuit;

end parser_sdl;
