------------------------------------------------------------------------------
-- BUSH Stats Package Parser                                               --
--                                                                          --
-- Part of BUSH                                                             --
------------------------------------------------------------------------------
--                                                                          --
--              Copyright (C) 2001-2004 Ken O. Burtch & FSF                 --
--                                                                          --
-- This is free software;  you can  redistribute it  and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion.  This is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License  distributed with this;  see file COPYING.  If not, write --
-- to  the Free Software Foundation,  59 Temple Place - Suite 330,  Boston, --
-- MA 02111-1307, USA.                                                      --
--                                                                          --
-- This is maintained at http://www.pegasoft.ca                             --
--                                                                          --
------------------------------------------------------------------------------
-- CVS: $Header: /home/cvsroot/ada/bush/parser_arrays.ads,v 1.1.1.1 2003/10/16 03:08:05 ken Exp $

with ada.strings.unbounded, world, scanner;
use  ada.strings.unbounded, world, scanner;

package parser_stats is

------------------------------------------------------------------------------
-- Stats package identifiers
------------------------------------------------------------------------------

stats_average_t  : identifier;
stats_max_t      : identifier;
stats_min_t      : identifier;
stats_standard_deviation_t : identifier;
stats_sum_t      : identifier;
stats_variance_t : identifier;

-----------------------------------------------------------------------------
-- HOUSEKEEPING
------------------------------------------------------------------------------

procedure StartupStats;
procedure ShutdownStats;

------------------------------------------------------------------------------
-- PARSE THE STATS PACKAGE
------------------------------------------------------------------------------

procedure ParseStatsAverage( f : out unbounded_string; kind : out identifier );
procedure ParseStatsMax( f : out unbounded_string; kind : out identifier );
procedure ParseStatsMin( f : out unbounded_string; kind : out identifier );
procedure ParseStatsStandardDeviation( f : out unbounded_string; kind : out identifier );
procedure ParseStatsSum( f : out unbounded_string; kind : out identifier );
procedure ParseStatsVariance( f : out unbounded_string; kind : out identifier );

end parser_stats;
